#include "opener_context_resource.h"
#include "opener_context_object_server.h"
#include "opener_resource.h"
#include "resource_server.h"

/* Support for providing access to files. */

OpenerContextResource::OpenerContextResource(OpenerResource *opener, Memory *memory)
: SimplePager(memory), _opener(opener)
{
}

int OpenerContextResource::expected_items()
{
    return OpenerContextObject_expected_items;
}

ipc_server_handler_type OpenerContextResource::handler()
{
    return (ipc_server_handler_type) handle_OpenerContextObject;
}



/* Data access methods. */

char *OpenerContextResource::get_path()
{
    return _region->read();
}



/* Opener context interface methods. */

long OpenerContextResource::open(int flags, size_t *size, l4_cap_idx_t *file)
{
    /* NOTE: Support flags in the file pager method and obtain the file size. */

    FilePager *pager = _opener->open(get_path());

    /* Complete the initialisation and start a server in a new thread. */

    ResourceServer server(pager);
    long err = server.start_thread();

    /* Return the file size. */
    /* Return the server capability to the caller. */

    *size = pager->get_data_size();
    *file = server.config()->server;
    return err;
}

// vim: tabstop=4 expandtab shiftwidth=4
